<script>
    import MapX4 from "./MapX4.svelte";
    export let x;
    export let y;
    export let width;
    export let height;
    export let els;
    export let sub;

    export let tx;
    export let ty;
    export let scale;
    export let stepScale;
    export let cw;
    export let ch;
    export let vl;

    let lWidth;
    let lHeight;
    let lScale;
    let left;
    let right;
    let top;
    let bottom;
    let hVisible;
    let vVisible;
    let visible;

    $: lWidth = width * stepScale;
    $: lHeight = height * stepScale;
    $: lScale = scale / stepScale;
    $: left = x * scale + tx;
    $: right = left + lWidth * scale;
    $: top = y * scale + ty;
    $: bottom = top + lHeight * scale;
    $: hVisible = left < cw && right > 0;
    $: vVisible = top < ch && bottom > 0;
    $: visible = hVisible && vVisible;
</script>

{#if (visible)}
<div class="l1 map"
     style="width: {stepScale === 2 ? lWidth : 0}px;
        height: {stepScale === 2 ? lHeight : 0}px;
        transform: {stepScale === 2 && visible ? 'translate(' + left + 'px, ' + top + 'px) scale(' + lScale + ')' : ''};
        position: {stepScale === 2 ? 'absolute' : 'static'};
        will-change: {stepScale === 2 && visible ? 'transform' : ''};"
>
    {#each sub as item}
        <MapX4
                bind:x={item.x}
                bind:y={item.y}
                bind:width={item.width}
                bind:height={item.height}
                bind:els={item.els}
                bind:sub={item.sub}
                bind:tx={tx}
                bind:ty={ty}
                bind:stepScale={stepScale}
                bind:scale={scale}
                bind:cw={cw}
                bind:ch={ch}
                bind:l1x={x}
                bind:l1y={y}
                bind:vl={vl}
        />
    {/each}
</div>
{/if}
